/// <reference types="react" />
import type { AxisContextType, PlotContextType, ReducerActions, State } from './types';
interface DispatchContextType {
    dispatch: ((action: ReducerActions) => void) | null;
}
export declare const PlotContext: import("react").Context<PlotContextType>;
export declare const DispatchContext: import("react").Context<DispatchContextType>;
export declare function usePlotContext(): PlotContextType;
export declare function useDispatchContext(): DispatchContextType;
interface SizeProps {
    plotWidth: number;
    plotHeight: number;
}
export declare function useAxisContext(state: State, { plotWidth, plotHeight }: SizeProps): Record<string, AxisContextType>;
declare type NumberOrString = number | string;
interface UsePositionConfig {
    x: NumberOrString;
    y: NumberOrString;
}
export declare function usePosition(config: UsePositionConfig): {
    x: string | number;
    y: string | number;
};
interface UsePositionAndSizeConfig extends UsePositionConfig {
    width: NumberOrString;
    height: NumberOrString;
}
export declare function usePositionAndSize(config: UsePositionAndSizeConfig): {
    x: string | number;
    y: string | number;
    width: string | number;
    height: string | number;
};
interface UseEllipsePositionConfig {
    cx: NumberOrString;
    cy: NumberOrString;
    rx: NumberOrString;
    ry: NumberOrString;
}
export declare function useEllipsePosition(props: UseEllipsePositionConfig): {
    cx: string | number;
    cy: string | number;
    rx: string | number;
    ry: string | number;
};
export {};
