"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const hooks_1 = require("../../hooks");
const VerticalText_1 = __importDefault(require("../VerticalText"));
const Ticks_1 = require("./Ticks");
function LeftAxis({ id, displayGridLines, hidden = false, label, labelSpace, labelStyle, fontSize, tickStyle, hiddenTicks = false, tickEmbedded, tickLength, hiddenSecondaryTicks, }) {
    const { axisContext, plotHeight, plotWidth } = hooks_1.usePlotContext();
    // Calculates the main axis values
    const { scale, scientific } = axisContext[id] || {};
    const ticks = react_1.useMemo(() => (scale === null || scale === void 0 ? void 0 : scale.ticks()) || [], [scale]);
    const range = (scale === null || scale === void 0 ? void 0 : scale.range()) || [0, 0];
    // Create gridlines
    const gridlines = react_1.useMemo(() => {
        if (!displayGridLines || !scale)
            return null;
        return (jsx_runtime_1.jsx("g", Object.assign({ className: "gridLines" }, { children: ticks.map((val) => (jsx_runtime_1.jsx("line", { x1: "0", x2: plotWidth, y1: scale(val), y2: scale(val), stroke: "black", strokeDasharray: "2,2", strokeOpacity: 0.5 }, val))) }), void 0));
    }, [displayGridLines, ticks, scale, plotWidth]);
    const tickDirection = tickEmbedded ? 1 : -1;
    const tickLen = tickDirection * tickLength;
    const tickTextPosition = tickEmbedded ? -8 : -8 + tickLen;
    return (jsx_runtime_1.jsxs("g", Object.assign({ className: "axis" }, { children: [gridlines, !hidden && (jsx_runtime_1.jsxs("g", Object.assign({ className: "ticks" }, { children: [jsx_runtime_1.jsx("line", { y1: range[0], y2: range[1], stroke: "black" }, void 0),
                    jsx_runtime_1.jsx(Ticks_1.Ticks, { scientific: scientific, scale: scale, hidden: hiddenTicks, ticks: ticks, style: tickStyle, hiddenSecondaryTicks: hiddenSecondaryTicks, getPositions: (y) => ({
                            line: { x2: tickLen, y1: y, y2: y },
                            text: { x1: tickTextPosition, y1: y },
                        }) }, void 0)] }), void 0)),
            label && !hidden && (jsx_runtime_1.jsx(VerticalText_1.default, { label: label, transform: `translate(${0 - fontSize - labelSpace - (scientific ? 14 : 0)}, ${plotHeight / 2})`, dy: fontSize, fontSize: fontSize, style: labelStyle }, void 0))] }), void 0));
}
exports.default = LeftAxis;
