"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const hooks_1 = require("../hooks");
function yTranslation(position, height) {
    switch (position) {
        case 'top': {
            return 20;
        }
        case 'bottom': {
            return height + 64;
        }
        default: {
            throw new Error(`Unknown ${JSON.stringify(position)} position`);
        }
    }
}
function Heading({ title, titleStyle, titleClass, subtitle, subtitleStyle, subtitleClass, position = 'top', }) {
    const { width, height, bottom } = hooks_1.usePlotContext();
    const defaultTitleStyle = {
        textAnchor: 'middle',
        fontSize: '16px',
        fontWeight: 'bold',
    };
    const defaultSubtitleStyle = {
        textAnchor: 'middle',
        fontSize: '14px',
        color: 'gray',
    };
    const bottomHeigth = height - bottom;
    const y = yTranslation(position, bottomHeigth);
    return (jsx_runtime_1.jsxs("g", Object.assign({ transform: `translate(${width / 2}, ${y})` }, { children: [jsx_runtime_1.jsx("text", Object.assign({ style: { ...defaultTitleStyle, ...titleStyle }, className: titleClass }, { children: title }), void 0),
            subtitle && (jsx_runtime_1.jsx("text", Object.assign({ transform: "translate(0, 20)", style: { ...defaultSubtitleStyle, ...subtitleStyle }, className: subtitleClass }, { children: subtitle }), void 0))] }), void 0));
}
exports.default = Heading;
